Index: typo3/sysext/css_styled_content/static/constants.txt
===================================================================
--- typo3/sysext/css_styled_content/static/constants.txt	(revision 7400)
+++ typo3/sysext/css_styled_content/static/constants.txt	(working copy)
@@ -35,7 +35,7 @@
   maxW = 600
     # cat=content/cImage/b2; type=int+; label= Max Image Width (Text): Same as above, but this is the maximum width when text is wrapped around an imageblock. Default is 50% of the normal Max Image Width.
   maxWInText =
-    # cat=content/cImage/c1; type=int+; label= Default Image Width: This indicates that default number of pixels (width) a block of images inserted as content will consume, if the user didn't specify otherwise in the content object.
+    # cat=content/cImage/c1; type=int+; label= Click-enlarge Image Width: This specifies the width of the image that will be opened in a new window when an image with the "Click-enlarge" option enabled is clicked on.
   linkWrap.width = 800m
   linkWrap.height = 600m
   linkWrap.effects =
Index: typo3/sysext/css_styled_content/static/v3.9/constants.txt
===================================================================
--- typo3/sysext/css_styled_content/static/v3.9/constants.txt	(revision 7400)
+++ typo3/sysext/css_styled_content/static/v3.9/constants.txt	(working copy)
@@ -32,7 +32,7 @@
   maxW = 600
     # cat=content/cImage/b2; type=int+; label= Max Image Width (Text): Same as above, but this is the maximum width when text is wrapped around an imageblock. Default is 50% of the normal Max Image Width.
   maxWInText =
-    # cat=content/cImage/c1; type=int+; label= Default Image Width: This indicates that default number of pixels (width) a block of images inserted as content will consume, if the user didn't specify otherwise in the content object.
+    # cat=content/cImage/c1; type=int+; label= Click-enlarge Image Width: This specifies the width of the image that will be opened in a new window when an image with the "Click-enlarge" option enabled is clicked on.
   linkWrap.width = 800m
   linkWrap.height = 600m
   linkWrap.effects =
Index: typo3/sysext/css_styled_content/static/v4.2/constants.txt
===================================================================
--- typo3/sysext/css_styled_content/static/v4.2/constants.txt	(revision 7400)
+++ typo3/sysext/css_styled_content/static/v4.2/constants.txt	(working copy)
@@ -32,7 +32,7 @@
   maxW = 600
     # cat=content/cImage/b2; type=int+; label= Max Image Width (Text): Same as above, but this is the maximum width when text is wrapped around an imageblock. Default is 50% of the normal Max Image Width.
   maxWInText =
-    # cat=content/cImage/c1; type=int+; label= Default Image Width: This indicates that default number of pixels (width) a block of images inserted as content will consume, if the user didn't specify otherwise in the content object.
+    # cat=content/cImage/c1; type=int+; label= Click-enlarge Image Width: This specifies the width of the image that will be opened in a new window when an image with the "Click-enlarge" option enabled is clicked on.
   linkWrap.width = 800m
   linkWrap.height = 600m
   linkWrap.effects =
Index: typo3/sysext/css_styled_content/static/v4.3/constants.txt
===================================================================
--- typo3/sysext/css_styled_content/static/v4.3/constants.txt	(revision 7400)
+++ typo3/sysext/css_styled_content/static/v4.3/constants.txt	(working copy)
@@ -35,7 +35,7 @@
   maxW = 600
     # cat=content/cImage/b2; type=int+; label= Max Image Width (Text): Same as above, but this is the maximum width when text is wrapped around an imageblock. Default is 50% of the normal Max Image Width.
   maxWInText =
-    # cat=content/cImage/c1; type=int+; label= Default Image Width: This indicates that default number of pixels (width) a block of images inserted as content will consume, if the user didn't specify otherwise in the content object.
+    # cat=content/cImage/c1; type=int+; label= Click-enlarge Image Width: This specifies the width of the image that will be opened in a new window when an image with the "Click-enlarge" option enabled is clicked on.
   linkWrap.width = 800m
   linkWrap.height = 600m
   linkWrap.effects =