diff -ru typo3_src-4.0-orig/t3lib/class.t3lib_tcemain.php typo3_src-4.0-dev/t3lib/class.t3lib_tcemain.php
--- typo3_src-4.0-orig/t3lib/class.t3lib_tcemain.php	2006-04-07 02:18:29.000000000 +0200
+++ typo3_src-4.0-dev/t3lib/class.t3lib_tcemain.php	2006-07-06 12:02:35.000000000 +0200
@@ -921,18 +921,21 @@
 								// Permissions can be edited by the owner or the administrator
 							if ($table=='pages' && ($this->admin || $status=='new' || $this->pageInfo($id,'perms_userid')==$this->userid) )	{
 								$value=intval($fieldValue);
-								switch($field)	{
-									case 'perms_userid':
-										$fieldArray[$field]=$value;
-									break;
-									case 'perms_groupid':
-										$fieldArray[$field]=$value;
-									break;
-									default:
-										if ($value>=0 && $value<pow(2,5))	{
+								$_set = t3lib_div::_GP('set');
+								if ($_set[$field] == true) {
+									switch($field)	{
+										case 'perms_userid':
 											$fieldArray[$field]=$value;
-										}
-									break;
+										break;
+										case 'perms_groupid':
+											$fieldArray[$field]=$value;
+										break;
+										default:
+											if ($value>=0 && $value<pow(2,5))	{
+												$fieldArray[$field]=$value;
+											}
+										break;
+									}
 								}
 							}
 						break;
diff -ru typo3_src-4.0-orig/typo3/mod/web/perm/index.php typo3_src-4.0-dev/typo3/mod/web/perm/index.php
--- typo3_src-4.0-orig/typo3/mod/web/perm/index.php	2006-04-07 02:18:29.000000000 +0200
+++ typo3_src-4.0-dev/typo3/mod/web/perm/index.php	2006-07-06 12:00:27.000000000 +0200
@@ -343,8 +343,10 @@
 			<select name="data[pages]['.$this->id.'][perms_userid]">
 				'.$options.'
 			</select>';
+		$set='
+			<input type="checkbox" name="set[perms_userid]" value="1" checked="checked" /> '.$LANG->getLL('SetOwner');
 
-		$this->content.=$this->doc->section($LANG->getLL('Owner').':',$selector);
+		$this->content.=$this->doc->section($LANG->getLL('Owner').':',$selector.$set);
 
 
 			// Group selector:
@@ -371,9 +373,11 @@
 			<select name="data[pages]['.$this->id.'][perms_groupid]">
 				'.$options.'
 			</select>';
+		$set='
+			<input type="checkbox" name="set[perms_groupid]" value="1" checked="checked" /> '.$LANG->getLL('SetGroup');
 
 		$this->content.=$this->doc->divider(5);
-		$this->content.=$this->doc->section($LANG->getLL('Group').':',$selector);
+		$this->content.=$this->doc->section($LANG->getLL('Group').':',$selector.$set);
 
 			// Permissions checkbox matrix:
 		$code='
@@ -385,6 +389,7 @@
 					<td class="bgColor2">'.str_replace(' ','<br />',$LANG->getLL('2',1)).'</td>
 					<td class="bgColor2">'.str_replace(' ','<br />',$LANG->getLL('4',1)).'</td>
 					<td class="bgColor2">'.str_replace(' ','<br />',$LANG->getLL('8',1)).'</td>
+					<td class="bgColor2">'.str_replace(' ','<br />',$LANG->getLL('SetPerm',1)).'</td>
 				</tr>
 				<tr>
 					<td align="right" class="bgColor2">'.$LANG->getLL('Owner',1).'</td>
@@ -393,6 +398,7 @@
 					<td class="bgColor-20">'.$this->printCheckBox('perms_user',2).'</td>
 					<td class="bgColor-20">'.$this->printCheckBox('perms_user',3).'</td>
 					<td class="bgColor-20">'.$this->printCheckBox('perms_user',4).'</td>
+					<td class="bgColor-20"><input type="checkbox" name="set[perms_user]" value="1" checked="checked" /></td>
 				</tr>
 				<tr>
 					<td align="right" class="bgColor2">'.$LANG->getLL('Group',1).'</td>
@@ -401,6 +407,7 @@
 					<td class="bgColor-20">'.$this->printCheckBox('perms_group',2).'</td>
 					<td class="bgColor-20">'.$this->printCheckBox('perms_group',3).'</td>
 					<td class="bgColor-20">'.$this->printCheckBox('perms_group',4).'</td>
+					<td class="bgColor-20"><input type="checkbox" name="set[perms_group]" value="1" checked="checked" /></td>
 				</tr>
 				<tr>
 					<td align="right" class="bgColor2">'.$LANG->getLL('Everybody',1).'</td>
@@ -409,6 +416,7 @@
 					<td class="bgColor-20">'.$this->printCheckBox('perms_everybody',2).'</td>
 					<td class="bgColor-20">'.$this->printCheckBox('perms_everybody',3).'</td>
 					<td class="bgColor-20">'.$this->printCheckBox('perms_everybody',4).'</td>
+					<td class="bgColor-20"><input type="checkbox" name="set[perms_everybody]" value="1" checked="checked" /></td>
 				</tr>
 			</table>
 			<br />
diff -ru typo3_src-4.0-orig/typo3/sysext/lang/locallang_mod_web_perm.xml typo3_src-4.0-dev/typo3/sysext/lang/locallang_mod_web_perm.xml
--- typo3_src-4.0-orig/typo3/sysext/lang/locallang_mod_web_perm.xml	2006-04-07 02:18:29.000000000 +0200
+++ typo3_src-4.0-dev/typo3/sysext/lang/locallang_mod_web_perm.xml	2006-07-06 11:25:56.000000000 +0200
@@ -10,8 +10,11 @@
 			<label index="ch_permissions">Change permissions</label>
 			<label index="Legend">Legend</label>
 			<label index="Owner">Owner</label>
+			<label index="SetOwner">Set Owner?</label>
 			<label index="Group">Group</label>
+			<label index="SetGroup">Set Group?</label>
 			<label index="Everybody">Everybody</label>
+			<label index="SetPerm">Set Permissions?</label>
 			<label index="EditLock">Lock</label>
 			<label index="EditLock_descr">The page and all content is locked for editing by all non-Admin users.</label>
 			<label index="Save">Save</label>