--- l10n.orig/de/lang/de.locallang_mod_user_ws.xml	2006-08-03 15:17:32.217668004 +0200
+++ l10n/de/lang/de.locallang_mod_user_ws.xml	2006-08-03 15:22:29.177452211 +0200
@@ -7,7 +7,7 @@
 			<label index="mlang_tabs_tab">Workspace</label>
 			<label index="title">Workspace Manager</label>
 			<label index="menuitem_review">Überprüfen und Veröffentlichen</label>
-			<label index="menuitem_workspaces">Workspace Liste</label>
+			<label index="menuitem_workspaces">Workspace-Liste</label>
 			<label index="filter_drafts">Entwürfe</label>
 			<label index="filter_archive">Archiv</label>
 			<label index="filter_all">Alle</label>
@@ -37,6 +37,8 @@
 			<label index="label_stage">Stufe:</label>
 			<label index="label_publish">Veröffentlichen</label>
 			<label index="label_lifecycle">Lebenszyklus:</label>
+			<label index="label_accesslevel">Zugriffslevel:</label>
+			<label index="label_showsubelements">Zeige Unterelemente</label>
 			<label index="img_title_publish">Veröffentlichen</label>
 			<label index="img_title_swap">Austauschen</label>
 			<label index="remove_from_ws_confirmation">Aus dem Workspace entfernen?</label>
@@ -81,12 +83,21 @@
 			<label index="workspace_list_publishing_count_draft">Entwurf</label>
 			<label index="workspace_list_publishing_count_archive">Archiv</label>
 			<label index="workspace_list_publishing_count">%d mal veröffentlicht</label>
+			<label index="label_reject">Zurückweisen</label>
+			<label index="label_sendtoreview">Zur Kontrolle senden</label>
+			<label index="label_approveforpublishing">Zum Publizieren freigeben</label>
 			<label index="stage_sent_to_review">&quot;%s&quot; hat das Element an &quot;Review&quot; geschickt</label>
 			<label index="stage_approved_for_publish">&quot;%s&quot; hat &quot;Veröffentlichen&quot; bestätigt</label>
 			<label index="stage_rejected">&quot;%s&quot; hat das Element zurück gewiesen!</label>
+			<label index="label_rejected">Zurückgewiesen</label>
+			<label index="explain_reject">Bitte begründen Sie, warum Sie die Änderungen zurückweisen:</label>
 			<label index="stage_reset_to_editing">&quot;%s&quot; hat das Element auf &quot;Bearbeiten&quot; zurückgesetzt</label>
 			<label index="stage_undefined">[undefiniert]</label>
 			<label index="stage_label_user_comment">Benutzerkommentar:</label>
+			<label index="stage_editing">Bearbeiten</label>
+			<label index="stage_review">Kontrolle</label>
+			<label index="stage_publish">Publizieren</label>
+			<label index="label_review">Kontrolle</label>
 			<label index="workspace_list_mount_point_inaccessible">Dieser Mount-Point ist für den Workspace definiert, Sie haben aber keinen Zugriff. Wenn Sie Zugriff zu diesem Mount-Point benötigen, bitten Sie Ihren System-Administrator, Ihnen den Zugriff zu gewähren.</label>
 			<label index="workspace_list_file_mount_point_live">Mount-Points des Benutzer-Profils werden benutzt.</label>
 			<label index="workspace_list_file_mount_point_draft">Datei-Mount-Points sind im Draft-Workspace nicht verwendbar</label>
@@ -94,6 +105,19 @@
 			<label index="workspace_list_db_mount_point_live">Mount-Points des Benutzer-Profils werden benutzt.</label>
 			<label index="workspace_list_db_mount_point_draft">Mount-Points des Benutzer-Profils werden benutzt.</label>
 			<label index="workspace_list_db_mount_point_custom">Mount-Points des Benutzer-Profils werden benutzt.</label>
+			<label index="label_subelements">Unterelemente</label>
+			<label index="label_subelementsdetails">Unterelemente, für Details klicken</label>
+			<label index="label_commentforreviewer">Kommentar für [Reviewer]:</label>
+			<label index="label_commentforpublisher">Kommentar für [Publisher]:</label>
+			<label index="label_resetstage">Status zurücksetzen</label>
+			<label index="label_undefined">[Undefiniert]</label>
+			<label index="label_element">Element</label>
+			<label index="label_page">Seite</label>
+			<label index="label_branch">Zweig</label>
+			<label index="label_newrecord">Neues Element</label>
+			<label index="label_otherversions">Weitere Version(en) im Workspace</label>
+			<label index="label_offlineWSes">Entwurfs-Workspaces</label>
+			<label index="label_allWSes">Alle Workspaces</label>
 		</languageKey>
 	</data>
 	<orig_hash type="array">
@@ -190,6 +214,7 @@
 			<label index="workspace_list_db_mount_point_live" type="integer">55306575</label>
 			<label index="workspace_list_db_mount_point_draft" type="integer">55306575</label>
 			<label index="workspace_list_db_mount_point_custom" type="integer">55306575</label>
+			<label index="label_onlymychanges">Nur meine Änderungen anzeigen</label>
 		</languageKey>
 	</orig_hash>
 	<orig_text type="array">
@@ -255,6 +280,8 @@
 			<label index="workspace_list_icon_title_edit_workspace">Edit workspace</label>
 			<label index="workspace_list_icon_title_switch_workspace">Switch workspace</label>
 			<label index="label_lifecycle">Lifecycle:</label>
+			<label index="label_accesslevel">Access level:</label>
+			<label index="label_showsubelements">Show sub elements</label>
 			<label index="label_publish">Publish:</label>
 			<label index="img_title_publish">Publish</label>
 			<label index="workspace_list_publishing_count_draft">Draft</label>
@@ -286,6 +313,28 @@
 			<label index="workspace_list_db_mount_point_live">Mount points from user profile are used.</label>
 			<label index="workspace_list_db_mount_point_draft">Mount points from user profile are used.</label>
 			<label index="workspace_list_db_mount_point_custom">Mount points from user profile are used.</label>
+			<label index="label_reject">Reject</label>
+			<label index="label_review">Review</label>
+			<label index="label_sendtoreview">Send to review</label>
+			<label index="label_approveforpublishing">Approve for publishing</label>
+			<label index="stage_editing">Editing</label>
+			<label index="stage_review">Review</label>
+			<label index="stage_publish">Publish</label>
+			<label index="label_subelements">Sub elements</label>
+			<label index="label_subelementsdetails">Sub elements, click for details</label>
+			<label index="label_commentforreviewer">Comment for Reviewer:</label>
+			<label index="label_commentforpublisher">Comment for Publisher:</label>
+			<label index="label_resetstage">Reset stage</label>
+			<label index="label_undefined">Undefined</label>
+			<label index="explain_reject">Please explain why you reject:</label>
+			<label index="label_element">Element</label>
+			<label index="label_page">Page</label>
+			<label index="label_branch">Branch</label>
+			<label index="label_newrecord">New element</label>
+			<label index="label_otherversions">Other version(s) in workspace</label>
+			<label index="label_rejected">Rejected</label>
+			<label index="label_offlineWSes">Draft workspaces</label>
+			<label index="label_allWSes">All workspaces</label>
 		</languageKey>
 	</orig_text>
 </T3locallangExt>