Index: /var/www/typo3_src-svn/t3lib/class.t3lib_browsetree.php
===================================================================
--- /var/www/typo3_src-svn/t3lib/class.t3lib_browsetree.php	(revision 2451)
+++ /var/www/typo3_src-svn/t3lib/class.t3lib_browsetree.php	(working copy)
@@ -146,7 +146,7 @@
 	}
 
 	/**
-	 * Returns the title for the input record. If blank, a "no title" labele (localized) will be returned.
+	 * Returns the title for the input record. If blank, a "no title" lable (localized) will be returned.
 	 * Do NOT htmlspecialchar the string from this function - has already been done.
 	 *
 	 * @param	array		The input row array (where the key "title" is used for the title)
@@ -154,7 +154,8 @@
 	 * @return	string		The title.
 	 */
 	function getTitleStr($row,$titleLen=30)	{
-		$title = (!strcmp(trim($row['title']),'')) ? '<em>['.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:labels.no_title',1).']</em>' : htmlspecialchars(t3lib_div::fixed_lgd_cs($row['title'],$titleLen));
+			// get the basic title from the parent implementation in t3lib_treeview
+		$title = parent::getTitleStr($row,$titleLen);
 		if (isset($row['is_siteroot']) && $row['is_siteroot'] != 0 && $GLOBALS['BE_USER']->getTSConfigVal('options.pageTree.showDomainNameWithTitle')) {
 			$rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('domainName,sorting', 'sys_domain',
 						'pid=' . $GLOBALS['TYPO3_DB']->quoteStr($row['uid'], 'sys_domain'), '', 'sorting', 1);
Index: /var/www/typo3_src-svn/t3lib/class.t3lib_treeview.php
===================================================================
--- /var/www/typo3_src-svn/t3lib/class.t3lib_treeview.php	(revision 2451)
+++ /var/www/typo3_src-svn/t3lib/class.t3lib_treeview.php	(working copy)
@@ -667,7 +667,7 @@
 
 
 	/**
-	 * Returns the title for the input record. If blank, a "no title" labele (localized) will be returned.
+	 * Returns the title for the input record. If blank, a "no title" lable (localized) will be returned.
 	 * Do NOT htmlspecialchar the string from this function - has already been done.
 	 *
 	 * @param	array		The input row array (where the key "title" is used for the title)
@@ -675,8 +675,13 @@
 	 * @return	string		The title.
 	 */
 	function getTitleStr($row,$titleLen=30)	{
-		$title = (!strcmp(trim($row['title']),'')) ? '<em>['.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:labels.no_title',1).']</em>' : htmlspecialchars(t3lib_div::fixed_lgd_cs($row['title'],$titleLen));
-		return $title;
+		if ($this->ext_showNavTitle && strlen($row['nav_title']) > 0)	{
+			$title = trim($row['nav_title']);
+		} else {
+			$title = (strlen(trim($row['title'])) == 0) ? '<em>['.$GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.php:labels.no_title',1).']</em>' : $row['title'];
+		}
+		
+		return t3lib_div::fixed_lgd_cs($title,$titleLen);
 	}
 
 	/**
Index: /var/www/typo3_src-svn/typo3/alt_db_navframe.php
===================================================================
--- /var/www/typo3_src-svn/typo3/alt_db_navframe.php	(revision 2451)
+++ /var/www/typo3_src-svn/typo3/alt_db_navframe.php	(working copy)
@@ -107,6 +107,7 @@
 		$this->pagetree = t3lib_div::makeInstance('webPageTree');
 		$this->pagetree->ext_IconMode = $BE_USER->getTSConfigVal('options.pageTree.disableIconLinkToContextmenu');
 		$this->pagetree->ext_showPageId = $BE_USER->getTSConfigVal('options.pageTree.showPageIdWithTitle');
+		$this->pagetree->ext_showNavTitle = $BE_USER->getTSConfigVal('options.pageTree.showNavTitle');
 		$this->pagetree->thisScript = 'alt_db_navframe.php';
 		$this->pagetree->addField('alias');
 		$this->pagetree->addField('shortcut');
@@ -114,6 +115,7 @@
 		$this->pagetree->addField('mount_pid');
 		$this->pagetree->addField('mount_pid_ol');
 		$this->pagetree->addField('nav_hide');
+		$this->pagetree->addField('nav_title');
 		$this->pagetree->addField('url');
 
 			// Temporary DB mounts:
Index: /var/www/typo3_src-svn/typo3/class.browse_links.php
===================================================================
--- /var/www/typo3_src-svn/typo3/class.browse_links.php	(revision 2451)
+++ /var/www/typo3_src-svn/typo3/class.browse_links.php	(working copy)
@@ -1448,6 +1448,8 @@
 		$pagetree = t3lib_div::makeInstance('TBE_PageTree');
 		$pagetree->thisScript=$this->thisScript;
 		$pagetree->ext_pArrPages = !strcmp($pArr[3],'pages')?1:0;
+		$pagetree->ext_showNavTitle = $GLOBALS['BE_USER']->getTSConfigVal('options.pageTree.showNavTitle');
+		$pagetree->addField('nav_title');
 		$tree=$pagetree->getBrowsableTree();
 
 			// Making the list of elements, if applicable:
Index: /var/www/typo3_src-svn/typo3/sysext/rtehtmlarea/mod3/class.tx_rtehtmlarea_browse_links.php
===================================================================
--- /var/www/typo3_src-svn/typo3/sysext/rtehtmlarea/mod3/class.tx_rtehtmlarea_browse_links.php	(revision 2451)
+++ /var/www/typo3_src-svn/typo3/sysext/rtehtmlarea/mod3/class.tx_rtehtmlarea_browse_links.php	(working copy)
@@ -785,6 +785,8 @@
 				$content.=$this->addAttributesForm();
 				
 				$pagetree = t3lib_div::makeInstance('tx_rtehtmlarea_pageTree');
+				$pagetree->ext_showNavTitle = $GLOBALS['BE_USER']->getTSConfigVal('options.pageTree.showNavTitle');
+				$pagetree->addField('nav_title');
 				$tree=$pagetree->getBrowsableTree();
 				$cElements = $this->expandPage();
 				$content.= '