diff -ru newloginbox.orig/res/newloginbox_00.html newloginbox/res/newloginbox_00.html
--- newloginbox.orig/res/newloginbox_00.html	2007-06-03 15:19:05.906250000 +0200
+++ newloginbox/res/newloginbox_00.html	2007-06-03 15:39:51.015625000 +0200
@@ -73,18 +73,26 @@
 <a name="template_login"></a><h1>TEMPLATE_LOGIN</h1>
 <p>This is the template for the login form with/without the 'forgot password' link.</p>
 
-<!--###TEMPLATE_LOGIN###-->
+<!-- ###TEMPLATE_LOGIN### -->
 
-<!--###HEADER_VALID###-->
+<!-- ###HEADER_VALID### -->
 <h3>###STATUS_HEADER###</h3>
-<!--###HEADER_VALID###-->
+<!-- ###HEADER_VALID### -->
 
-<!--###MESSAGE_VALID###-->
+<!-- ###MESSAGE_VALID### -->
 <p>###STATUS_MESSAGE###</p>
-<!--###MESSAGE_VALID###-->
+<!-- ###MESSAGE_VALID### -->
 
-<form action="###ACTION_URI###" target="_top" method="post" onSubmit="###ON_SUBMIT###">
+<form action="###ACTION_URI###" target="_top" method="post" onsubmit="###ON_SUBMIT###">
 	<table>
+		<tfoot>
+	 		<tr>
+	 			<td></td>
+	 			<td>
+	 				<input type="submit" name="submit" value="###LOGIN_LABEL###" />
+	 			</td>
+	 		</tr>
+		</tfoot>
 		<tbody>
 			<tr>
 				<th><label for="user">###USERNAME_LABEL###</label></th>
@@ -94,7 +102,7 @@
 				<th><label for="pass">###PASSWORD_LABEL###</label></th>
 				<td><input type="password" id="pass" name="pass" value="" /></td>
 			</tr>
-			<!--###PERMALOGIN_VALID###-->
+			<!-- ###PERMALOGIN_VALID### -->
 			<tr>
 				<th><label for="permalogin">###PERMALOGIN###</label></th>
 				<td>
@@ -102,16 +110,8 @@
 					<input name="permalogin" value="1" type="checkbox" ###PERMALOGIN_CHECKBOX_ATTRIBUTES### id="permalogin"  onclick="document.getElementById('permaloginHiddenField').disabled = this.checked;" />
 				</td>
 			</tr>
-			<!--###PERMALOGIN_VALID###-->
+			<!-- ###PERMALOGIN_VALID### -->
 		</tbody>
-		<tfoot>
-	 		<tr>
-	 			<td></td>
-	 			<td>
-	 				<input type="submit" name="submit" value="###LOGIN_LABEL###" />
-	 			</td>
-	 		</tr>
-		</tfoot>
 	</table>
 	<input type="hidden" name="logintype" value="login" />
 	<input type="hidden" name="pid" value="###STORAGE_PID###" />
@@ -119,11 +119,11 @@
 	###EXTRA_HIDDEN###
 </form>
 
-<!--###FORGOTP_VALID###-->
-<p><!--###FORGOTP_LINK###-->###FORGOT_PASSWORD###<!--###FORGOTP_LINK###--></p>
-<!--###FORGOTP_VALID###-->
+<!-- ###FORGOTP_VALID### -->
+<p><!-- ###FORGOTP_LINK### -->###FORGOT_PASSWORD###<!-- ###FORGOTP_LINK### --></p>
+<!-- ###FORGOTP_VALID### -->
 
-<!--###TEMPLATE_LOGIN###-->
+<!-- ###TEMPLATE_LOGIN### -->
 
 <!--=========================================================-->
 <p class="separator"><a href="#navigation">Navigation</a> | <a href="#">To top</a></p>
@@ -132,15 +132,15 @@
 <a name="template_logout"></a><h1>TEMPLATE_LOGOUT</h1>
 <p>This is the template shown after you logged in or displaying the status of current connection.</p>
 
-<!--###TEMPLATE_LOGOUT###-->
+<!-- ###TEMPLATE_LOGOUT### -->
 
-<!--###HEADER_VALID###-->
+<!-- ###HEADER_VALID### -->
 <h3>###STATUS_HEADER###</h3>
-<!--###HEADER_VALID###-->
+<!-- ###HEADER_VALID### -->
 
-<!--###MESSAGE_VALID###-->
+<!-- ###MESSAGE_VALID### -->
 <p>###STATUS_MESSAGE###</p>
-<!--###MESSAGE_VALID###-->
+<!-- ###MESSAGE_VALID### -->
 
 <form action="###ACTION_URI###" target="_top" method="post">
 	<table>
@@ -163,7 +163,7 @@
 	<input type="hidden" name="pid" value="###STORAGE_PID###" />
 </form>
 
-<!--###TEMPLATE_LOGOUT###-->
+<!-- ###TEMPLATE_LOGOUT### -->
 
 <!--=========================================================-->
 <p class="separator"><a href="#navigation">Navigation</a> | <a href="#">To top</a></p>
@@ -172,12 +172,12 @@
 <a name="template_success"></a><h1>TEMPLATE_SUCCESS</h1>
 <p>This is the template displayed when successfull login.</p>
 
-<!--###TEMPLATE_SUCCESS###-->
+<!-- ###TEMPLATE_SUCCESS### -->
 
 <h3>###STATUS_HEADER###</h3>
 <p>###STATUS_MESSAGE###</p>
 
-<!--###TEMPLATE_SUCCESS###-->
+<!-- ###TEMPLATE_SUCCESS### -->
 
 <!--=========================================================-->
 <p class="separator"><a href="#navigation">Navigation</a> | <a href="#">To top</a></p>
@@ -186,7 +186,7 @@
 <a name="template_forgot"></a><h1>TEMPLATE_FORGOT</h1>
 <p>This is the template made to mail you back your password to the adress you've registered.</p>
 
-<!--###TEMPLATE_FORGOT###-->
+<!-- ###TEMPLATE_FORGOT### -->
 
 <h3>###STATUS_HEADER###</h3>
 <p>###FORGOT_PASSWORD_ENTEREMAIL###</p>
@@ -200,14 +200,14 @@
 		</tfoot>
 		<tbody>
 			<tr>
-				<th><label for="###PREFIXID###[DATA][forgot_email]">###EMAIL_LABEL###</label></th>
-				<td><input type="text" name="###PREFIXID###[DATA][forgot_email]" /></td>
+				<th><label for="forgot_email">###EMAIL_LABEL###</label></th>
+				<td><input type="text" id="forgot_email" name="###PREFIXID###[DATA][forgot_email]" /></td>
 			</tr>
 		</tbody>
 	</table>
 </form>
 
-<!--###TEMPLATE_FORGOT###-->
+<!-- ###TEMPLATE_FORGOT### -->
 
 <!--=========================================================-->
 <p class="separator"><a href="#navigation">Navigation</a> | <a href="#">To top</a></p>
@@ -216,17 +216,17 @@
 <a name="template_forgot_sent"></a><h1>TEMPLATE_FORGOT_SENT</h1>
 <p>This is the template shown when password has been mailed back.</p>
 
-<!--###TEMPLATE_FORGOT_SENT###-->
+<!-- ###TEMPLATE_FORGOT_SENT### -->
 
 <h3>###STATUS_HEADER###</h3>
 <p>###STATUS_MESSAGE###</p>
 <p>###FORGOT_PASSWORD_BACKTOLOGIN###</p>
 
-<!--###TEMPLATE_FORGOT_SENT###-->
+<!-- ###TEMPLATE_FORGOT_SENT### -->
 
 <!--=========================================================-->
 <p class="separator"><a href="#navigation">Navigation</a> | <a href="#">To top</a></p>
 <!--=========================================================-->
 
 </body>
-</html>
\ No newline at end of file
+</html>